
//Copyright (C) 1998-2010 MKTMK Moscow, Russia
//e-mail: mktmk<at>narod.ru
//interpreter Open Basic (OB).

#include <comline.h>
#include <stdio.h>

#include <ob.h>

using namespace ob_charspace;

ob_obasic example_basic_interpreter;

typedef unsigned int example_typecodeerr;

extern const ob_type_small_char* example_englmessage[];

const char* example_get_file_name(char* str){

char* ptr=str;
char* ptr1=ptr;

for(;;){
if(*ptr=='\\') ptr1=ptr;
if(*ptr==0) break;
++ptr;
}//for

return ptr1+1;
}

class example_usererror{
example_typecodeerr code;
public:
example_usererror(example_typecodeerr c){code=c;}

virtual void release(ostream* os,const ob_type_small_char** currentmessage){
(*os)<<endl<<((currentmessage))[code]<<endl;
(*os)<<endl<<"code error= "<<(code)<<endl;
}

virtual example_typecodeerr getcode(){return code;}
virtual ~example_usererror(){}
};

void example_printmanystring(unsigned int num,const ob_type_char* name){
unsigned int i;
size_t k;
ob_type_char* p=(ob_type_char*)name;

for(i=0;i!=num;i++){
k=ob_strlen(p)-1;
cout<<endl<<"---string "<<i<<" ---> ";
cout<<p;
p+=k+1;
}//for

}

bool example_compare_string(ob_type_char* s1,ob_type_char* s2){

bool fl=true;

ob_type_stringsize i;
for(i=0;;++i){

if(s1[i]!=s2[i]){
fl=false;
break;
}//if

if(s1[i]==ob_const_endstring) break;
if(s2[i]==ob_const_endstring) break;
}//for

return fl;
}

void example_printpar(
const ob_type_char* parstring,
const ob_type_parnum *descrf,
const ob_type_parnum *descri,
const ob_type_parnum *descrc,
const ob_type_flo* parf,
const ob_type_int* pari,
const ob_type_char* parc){

unsigned int num=descrf[0]+descri[0]+descrc[0];
ob_type_parnum i;

cout<<endl<<"Number all parameters="<<num;
example_printmanystring(num,parstring);

cout<<endl<<"Number flo   parameters="<<descrf[0];
cout<<endl<<"Number int   parameters="<<descri[0];
cout<<endl<<"Number char* parameters="<<descrc[0];

for(i=0;i!=descrf[0];i++)
cout<<endl<<"descrf("<<(i+1)<<")="<<descrf[i+1]<<" parf("<<i<<")="<<parf[i];
for(i=0;i!=descri[0];i++)
cout<<endl<<"descri("<<(i+1)<<")="<<descri[i+1]<<" pari("<<i<<")="<<pari[i];
for(i=0;i!=descrc[0];i++)
cout<<endl<<"descrc("<<(i+1)<<")="<<descrc[i+1];
example_printmanystring(descrc[0],parc);
}

OB_DECLARE_USER_FUNCTION(example_userfun1,ob_type_flo){

cout<<endl<<"Work flo userfun";
example_printpar(parstring,descrf,descri,descrc,parf,pari,parc);

//example write and read float variable
ob_type_flo val=(ob_type_flo)3.62,val1;

if(basic_ptr->writevar((ob_type_char*)"VARFORUSERFUN1",val)==0) throw example_usererror(1);

if(basic_ptr->readvar((ob_type_char*)"VARFORUSERFUN1",&val1)==0) throw example_usererror(2);

if(val!=val1) throw example_usererror(3);

//example write and read element float array
//this array must be create by DIM operator
if(basic_ptr->writevar((ob_type_char*)"ARRAYFORUSERFUN1(1+1,5-2,1)",val)==0) throw example_usererror(4);

if(basic_ptr->readvar((ob_type_char*)"ARRAYFORUSERFUN1(USER_FUN2%()-1,3,1)",&val1)==0) throw example_usererror(5);

if(val!=val1) throw example_usererror(6);

if(basic_ptr->typevar((ob_type_char*)"VARFORUSERFUN1")!=OB_IDENTFLO) throw example_usererror(7);

if(basic_ptr->typearray((ob_type_char*)"ARRAYFORUSERFUN1")!=OB_IDENTFLO) throw example_usererror(8);

ob_type_arraysize kr;
const ob_type_arraysize* sr=basic_ptr->getarraysize((ob_type_char*)"ARRAYFORUSERFUN1",&kr);
if(sr==NULL) throw example_usererror(9);

cout<<endl<<"size of array:"<<kr;
ob_type_arraysize i;
for(i=0;i!=kr;i++) cout<<" dim("<<i<<")="<<sr[i];

ob_type_flo retdata=(ob_type_flo)1.123;
return retdata;
}

OB_DECLARE_USER_FUNCTION(example_userfun2,ob_type_int){

cout<<endl<<"Work int userfun";
if(basic_ptr->writevar((ob_type_char*)"jjj$",(ob_type_char*)"this is string for print syscall")==0) throw example_usererror(10);

example_printpar(parstring,descrf,descri,descrc,parf,pari,parc);

ob_type_int retdata=3;
return retdata;
}

OB_DECLARE_USER_FUNCTION(example_userfun3,ob_type_char*){

cout<<endl<<"Work char userfun and delete";

if(basic_ptr==NULL) cout<<endl<<"error";
example_printpar(parstring,descrf,descri,descrc,parf,pari,parc);
ob_type_char* s=(ob_type_char*)"string from userfun3";
ob_type_char* ptrchar=new ob_type_char[ob_strlen(s)+1];
ob_strcpy(ptrchar,s);
return ptrchar;
}

OB_DECLARE_USER_FUNCTION(example_userfun4,ob_type_char*){

cout<<endl<<"Work char userfun without delete";

if(basic_ptr==NULL) cout<<endl<<"error";
example_printpar(parstring,descrf,descri,descrc,parf,pari,parc);

ob_type_char* s=(ob_type_char*)"string from userfun4";
return s;
}

OB_DECLARE_USER_FUNCTION(console_version_flag,ob_type_int){
return 1;
}

#define OB_EXAMPLE_MAXNUMSWITCH 50
#define OB_EXAMPLE_MAXLENGTHSWITCH 512
#define OB_EXAMPLE_MAXINPUTFILENAME 30

void example_printhelpr(ostream& os,char* argv[]){

os<<endl<<"Usage: "<<example_get_file_name(argv[0])<<" [-sw1 -sw2 ...] f1 [f2...]";
os<<endl<<"switch are:";
os<<endl<<"fX       - name of *.bas file (max "<<OB_EXAMPLE_MAXINPUTFILENAME<<" files) f1 is start file";
os<<endl<<"-oXXXXXX - name of output file (default cout)";
os<<endl<<"-rXXXXXX - name of input file (default cin)";
os<<endl<<"-pXXXXXX - name of file of switch";
os<<endl<<"-nXXXXXX - name of operator break";
os<<endl<<"-b       - break before";
os<<endl<<"-a       - break after";
os<<endl<<"-?       - help";
os<<endl<<"-s       - step mode (stop after each line and print current line)";
os<<endl<<"-d       - direct I/O to/from cout/cin (default through functors)";
}

class example_paramcomlinedef{

void rdswitch1(int ob_argc,char *ob_argv[]){

for(numfile=0;numfile!=OB_EXAMPLE_MAXINPUTFILENAME;++numfile){
array_of_inputfilename[numfile]=0;
}//for

char* inputfilename;

for(numfile=0;numfile!=OB_EXAMPLE_MAXINPUTFILENAME;++numfile){

flf=comline_getnswstring(ob_argc,ob_argv,numfile,&inputfilename);

if(flf==false) break;

array_of_inputfilename[numfile]=inputfilename;
}//for

flo=comline_getswstring(ob_argc,ob_argv,'o',&outputfilename);
flr=comline_getswstring(ob_argc,ob_argv,'r',&readfilename);
fln=comline_getswstring(ob_argc,ob_argv,'n',&operbreakname);
flp=comline_getswstring(ob_argc,ob_argv,'p',&switchfilename);
fll=comline_getswstring(ob_argc,ob_argv,'l',&localename);

if(fll==false) localename=(char*)"rus_rus.866";

operbreakname1=operbreakname;

flh=comline_getswvalue(ob_argc,ob_argv,'?',(unsigned int*)0);
fls=comline_getswvalue(ob_argc,ob_argv,'s',(unsigned int*)0);
flb=comline_getswvalue(ob_argc,ob_argv,'b',(unsigned int*)0);
fla=comline_getswvalue(ob_argc,ob_argv,'a',(unsigned int*)0);
fl8=comline_getswvalue(ob_argc,ob_argv,'8',(unsigned int*)0);
fle=comline_getswvalue(ob_argc,ob_argv,'e',(unsigned int*)0);
fld=comline_getswvalue(ob_argc,ob_argv,'d',(unsigned int*)0);
}

void rdswitch_from_file(){

ifstream in;
in.open(switchfilename);

int i;
for(i=0;i!=OB_EXAMPLE_MAXNUMSWITCH;++i){
if(in.eof()==true) break;
in.getline(&(ob_argv[i][0]),OB_EXAMPLE_MAXLENGTHSWITCH);
}//for

ob_argc=i;
}

public:

example_paramcomlinedef();
~example_paramcomlinedef();

bool flh;
bool fls;

bool flf;

unsigned int numfile;

bool flo;
bool flr;
bool flp;
bool fll;

bool fln;
bool flb;
bool fla;

bool fl8;
bool fle;
bool fld;

char* array_of_inputfilename[OB_EXAMPLE_MAXINPUTFILENAME];
ob_ifstream array_of_inputfile[OB_EXAMPLE_MAXINPUTFILENAME];

char* outputfilename;
char* readfilename;
char* operbreakname;
char* switchfilename;
char* localename;

ob_type_char* operbreakname1;

ob_type_string operbreaknamestring;

int ob_argc;
char* ob_argv[OB_EXAMPLE_MAXNUMSWITCH];

void rdswitch(int argc,char *argv[]){

rdswitch1(argc,argv);

if(flp==true){
rdswitch_from_file();
rdswitch1(ob_argc,ob_argv);
}//if
}

};

example_paramcomlinedef::example_paramcomlinedef(){

int i;
for(i=0;i!=OB_EXAMPLE_MAXNUMSWITCH;++i){
ob_argv[i]=new char[OB_EXAMPLE_MAXLENGTHSWITCH];
}//for

}

example_paramcomlinedef::~example_paramcomlinedef(){

int i;
for(i=0;i!=OB_EXAMPLE_MAXNUMSWITCH;++i){
delete[] ob_argv[i];
}//for

}

example_paramcomlinedef example_paramcomline;

class ob_functor_break_print_def:public ob_functor_break_base{
ostringstream pr;
public:
ob_functor_break_print_def(){}
virtual ~ob_functor_break_print_def(){}

void run_before(ob_obasic* basicptr){
pr.clear();
pr.seekp(0);
basicptr->setout(&pr);
}

void run_after(ob_obasic* basicptr){

if(pr.str().length()!=0){
pr<<ends;

//-------------------------------------------------
cout<<pr.str().c_str();//your output code place here
//-------------------------------------------------

}//if
}
};

class ob_functor_break_input_def:public ob_functor_break_base{
char inputbuffer[ob_maxlengthstring];
char inputbuffer1[ob_maxlengthstring];
istringstream pr;
//strstream pr;
public:
ob_functor_break_input_def(){}
virtual ~ob_functor_break_input_def(){}

void run_before(ob_obasic* basicptr){

ob_lex::typelex tll=basicptr->gettypenextlex();
basicptr->restoreinputpointer();

if(tll!=ob_lex::SHARP){

inputbuffer[0]=0;

//-------------------------------------------------
cin>>inputbuffer;//your input code place here
//-------------------------------------------------

pr.clear();
pr.seekg(0);

pr.str(inputbuffer);

pr.seekg(0);
basicptr->setin(&pr);
}//if
}

void run_after(ob_obasic* basicptr){}
};

ob_functor_break_print_def ob_functor_break_print;
ob_functor_break_input_def ob_functor_break_input;

int main(int argc,char* argv[]){

int ret=0;

time_t startt=0;
time_t stopt;

time(&startt);

example_paramcomline.rdswitch(argc,argv);

cout<<endl<<ob_obasic::about();
cout<<endl<<"Command-line version. Use -? for help. SN="<<example_basic_interpreter.serial_number();
cout<<endl;

ob_type_char strbefore[ob_maxlengthstring];
ob_type_char strcurrent[ob_maxlengthstring];

ob_type_char strafter[ob_maxlengthstring];

if(example_paramcomline.flh==true){
example_printhelpr(cout,argv);
}//if
else{

  if(example_paramcomline.numfile!=0){

  try{

  ofstream po;
  ifstream pr;

  ob_ostreamcommon *ppo=&cout;
  ob_istreamcommon *ppr=&cin;

  if(example_paramcomline.fld==false){
  example_basic_interpreter.setoperatorbreak((char*)"PRINT",&ob_functor_break_print);
  example_basic_interpreter.setoperatorbreak((char*)"INPUT",&ob_functor_break_input);
  }//if
  
  if(example_paramcomline.flo==true){
  po.open(example_paramcomline.outputfilename);
  ppo=&po;
  }//if

  if(example_paramcomline.flr==true){
  pr.open(example_paramcomline.readfilename,ios::binary);
  ppr=&pr;
  }//if

  example_basic_interpreter.setin(ppr);
  example_basic_interpreter.setout(ppo);

  example_basic_interpreter.setfun((ob_type_char*)"USER_FUN1",example_userfun1);
  example_basic_interpreter.setfun((ob_type_char*)"USER_FUN2%",example_userfun2);
  example_basic_interpreter.setfun((ob_type_char*)"USER_FUN3",example_userfun3,OB_DELETE);
  example_basic_interpreter.setfun((ob_type_char*)"USER_FUN4",example_userfun4,OB_NODELETE);
  example_basic_interpreter.setfun((ob_type_char*)"CONSOLE_VERSION_FLAG%",console_version_flag);

  example_basic_interpreter.clear_project();

  unsigned int count_numfile;
  
  for(count_numfile=0;count_numfile!=example_paramcomline.numfile;++count_numfile){

  example_paramcomline.array_of_inputfile[count_numfile].open(example_paramcomline.array_of_inputfilename[count_numfile],ios::binary);

  example_basic_interpreter.load_project(&example_paramcomline.array_of_inputfile[count_numfile]);
  }//for

  if(example_paramcomline.fls==true) example_basic_interpreter.setstep(ob_obasic::STEP);

  ob_operator::flbreak bef;
  ob_operator::flbreak aft;

  if(example_paramcomline.flb==true) bef=ob_operator::BREAK; else bef=ob_operator::NOBREAK;
  if(example_paramcomline.fla==true) aft=ob_operator::BREAK; else aft=ob_operator::NOBREAK;

  if(example_paramcomline.fln==true){
  bool floperbreak=
  example_basic_interpreter.setoperatorbreak(example_paramcomline.operbreakname1,bef,aft);

  if(floperbreak==false) throw example_usererror(11);
  }//if

  ob_istreamcommon* cf=&example_paramcomline.array_of_inputfile[0];

  example_basic_interpreter.set_current_input_stream(cf);

m1:

  ob_obasic::typeend te=example_basic_interpreter.run();

  cf=example_basic_interpreter.get_current_input_stream();

  if((te==ob_obasic::EOLEND)&&(example_paramcomline.fls==true)){

  ob_loadbreakstr(cf,ob_maxlengthstring,strbefore,strcurrent,strafter);

  cout<<endl<<"String current: "<<strcurrent;
    for(;;){
      char ch;
      cout<<endl<<"Do you want continue? (Y/N):";
      cin>>ch;
      if((ch=='Y')||(ch=='y')) goto m1;
      if((ch=='N')||(ch=='n')) break;
    }//for
  }//if

  cout<<endl<<"Stop by stop code";
  cout<<endl<<"Stop code=";

  switch(te){
  case ob_obasic::ENDOPERATORDETECT  :cout<<"ENDOPERATORDETECT";break;
  case ob_obasic::ENDFILEEND         :cout<<"ENDFILEEND";break;
  case ob_obasic::BREAKPOINTEND      :cout<<"BREAKPOINTEND";break;
  case ob_obasic::NOLOADEND          :cout<<"NOLOADEND";break;
  case ob_obasic::BREAKBEFOREOPERATOR:cout<<"BREAKBEFOREOPERATOR";break;
  case ob_obasic::BREAKAFTEROPERATOR :cout<<"BREAKAFTEROPERATOR";break;
  case ob_obasic::EOLEND             :cout<<"EOLEND";break;
  default                            :cout<<"Unknown stop code";break;
  }//switch

  }//try

  catch(ob_err& e){

  cout<<endl<<"Stop by OB exception catch";
  ret=e.getcode();

  e.release(&cout,ob_englmessage);

  }//OB catch

  catch(example_usererror& e){

  cout<<endl<<"Stop by USER exception catch";
  ret=e.getcode();
  e.release(&cout,example_englmessage);

  }//USER catch

  ob_istreamcommon* cf=example_basic_interpreter.get_current_input_stream();

  ob_loadbreakstr(cf,ob_maxlengthstring,strbefore,strcurrent,strafter);

  cout<<endl<<"String  before: "<<strbefore;
  cout<<endl<<"String current: "<<strcurrent;
  cout<<endl<<"String   after: "<<strafter;

  }//if

}//else

time(&stopt);

struct tm t1;
struct tm t2;

t1=*localtime(&startt);
cout<<endl<<"Start time="<<t1.tm_hour<<":"<<t1.tm_min<<":"<<t1.tm_sec;

t2=*localtime(&stopt);
cout<<endl<<"Stop  time="<<t2.tm_hour<<":"<<t2.tm_min<<":"<<t2.tm_sec;

cout<<endl;//for Linux shell

return ret;
}

const ob_type_small_char* example_englmessage[]={
OB_STRINGDEFINE("End program OK"),                                        //0
OB_STRINGDEFINE("Error name var in writevar"),                            //1
OB_STRINGDEFINE("Error name var in readvar"),                             //2
OB_STRINGDEFINE("Not equal read and write var"),                          //3
OB_STRINGDEFINE("Error name array in writevar"),                          //4
OB_STRINGDEFINE("Error name array in readvar"),                           //5
OB_STRINGDEFINE("Not equal read and write element of array"),             //6
OB_STRINGDEFINE("Error ident var"),                                       //7
OB_STRINGDEFINE("Error ident array"),                                     //8
OB_STRINGDEFINE("Error size array"),                                      //9
OB_STRINGDEFINE("Error name var in string writevar"),                     //10
OB_STRINGDEFINE("Error name operator in set break before/after mode"),    //11
OB_STRINGDEFINE("stop message")
};


